diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/file.c cluster-3.0.0.rc3/gfs/gfs_fsck/file.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/file.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/file.c	2009-06-11 11:02:55.000000000 +0200
@@ -14,7 +14,7 @@
  *
  * Returns: The amount of data actually copied or the error
  */
-int readi(struct fsck_inode *ip, void *buf, uint64 offset, unsigned int size)
+int readi(struct fsck_inode *ip, void *bufin, uint64 offset, unsigned int size)
 {
 	struct fsck_sb *sdp = ip->i_sbd;
 	osi_buf_t *bh;
@@ -25,6 +25,7 @@
 	int journaled = fs_is_jdata(ip);
 	int copied = 0;
 	int error = 0;
+	char *buf = bufin;
 
 	if (offset >= ip->i_di.di_size){
 		log_debug("readi:  Offset (%"PRIu64") is >= "
@@ -110,7 +111,7 @@
  *
  * Returns: The number of bytes correctly written or error code
  */
-int writei(struct fsck_inode *ip, void *buf, uint64_t offset, unsigned int size)
+int writei(struct fsck_inode *ip, void *bufin, uint64_t offset, unsigned int size)
 {
 	struct fsck_sb *sdp = ip->i_sbd;
 	osi_buf_t *dibh, *bh;
@@ -122,6 +123,7 @@
 	const uint64_t start = offset;
 	int copied = 0;
 	int error = 0;
+	char *buf = bufin;
 
 	/*  Bomb out on writing nothing.
 	    Posix says we can't change the time here.  */
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/fs_bits.c cluster-3.0.0.rc3/gfs/gfs_fsck/fs_bits.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/fs_bits.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/fs_bits.c	2009-06-11 11:02:55.000000000 +0200
@@ -32,7 +32,7 @@
 	*byte |= new_state << bit;
 }
 
-uint32_t fs_bitfit_core(struct fsck_sb *sbp, uint64_t goal, uint64_t start, uint64_t len,
+static uint32_t fs_bitfit_core(struct fsck_sb *sbp, uint64_t goal, uint64_t start, uint64_t len,
 		   unsigned char old_state)
 {
 	uint64_t block;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/fs_dir.c cluster-3.0.0.rc3/gfs/gfs_fsck/fs_dir.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/fs_dir.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/fs_dir.c	2009-06-11 11:02:55.000000000 +0200
@@ -64,7 +64,7 @@
  *
  * Returns: 0 on success, error code otherwise
  */
-int dirent_next(osi_buf_t *bh, struct gfs_dirent **dent)
+static int dirent_next(osi_buf_t *bh, struct gfs_dirent **dent)
 {
 	struct gfs_dirent *tmp, *cur;
 	char *bh_end;
@@ -208,18 +208,18 @@
 /**
  * get_first_leaf - Get first leaf
  * @dip: The GFS inode
- * @index:
+ * @lindex:
  * @bh_out:
  *
  * Returns: 0 on success, error code otherwise
  */
 
-static int get_first_leaf(struct fsck_inode *dip, uint32 index, osi_buf_t **bh_out)
+static int get_first_leaf(struct fsck_inode *dip, uint32 lindex, osi_buf_t **bh_out)
 {
 	uint64 leaf_no;
 	int error;
 
-	error = get_leaf_nr(dip, index, &leaf_no);
+	error = get_leaf_nr(dip, lindex, &leaf_no);
 	if (!error)
 		error = get_leaf(dip, leaf_no, bh_out);
 
@@ -356,7 +356,7 @@
 			      struct gfs_dirent **dent_prev, osi_buf_t **bh_out)
 {
 	osi_buf_t *bh = NULL, *bh_next;
-	uint32 hsize, index;
+	uint32 hsize, lindex;
 	uint32 hash;
 	int error = 0;
 
@@ -370,9 +370,9 @@
 
 	if(id->type == ID_FILENAME){
 		hash = dir_hash(id->filename);
-		index = hash >> (32 - dip->i_di.di_depth);
+		lindex = hash >> (32 - dip->i_di.di_depth);
 
-		error = get_first_leaf(dip, index, &bh_next);
+		error = get_first_leaf(dip, lindex, &bh_next);
 		if (error){
 			return error;
 		}
@@ -403,8 +403,8 @@
 
 		relse_buf(dip->i_sbd, bh);
 	} else if(id->type == ID_INUM){
-		for(index=0; index < (1 << dip->i_di.di_depth); index++){
-			error = get_first_leaf(dip, index, &bh_next);
+		for(lindex=0; lindex < (1 << dip->i_di.di_depth); lindex++){
+			error = get_first_leaf(dip, lindex, &bh_next);
 			if (error){
 				return error;
 			}
@@ -732,12 +732,12 @@
 /**
  * dir_split_leaf - Split a leaf block into two
  * @dip: The GFS inode
- * @index:
+ * @lindex:
  * @leaf_no:
  *
  * Returns: 0 on success, error code on failure
  */
-static int dir_split_leaf(struct fsck_inode *dip, uint32 index, uint64 leaf_no)
+static int dir_split_leaf(struct fsck_inode *dip, uint32 lindex, uint64 leaf_no)
 {
 	struct fsck_sb *sdp = dip->i_sbd;
 	osi_buf_t *nbh, *obh, *dibh;
@@ -795,7 +795,7 @@
 	}
 	half_len = len >> 1;
 
-	start = (index & ~(len - 1));
+	start = (lindex & ~(len - 1));
 
 	log_debug("Splitting leaf: len = %u, half_len = %u\n", len, half_len);
 
@@ -1071,7 +1071,7 @@
 
 
 static int dir_e_del(struct fsck_inode *dip, osi_filename_t *filename){
-	int index;
+	int lindex;
 	int error;
 	int found = 0;
 	uint64 leaf_no;
@@ -1083,10 +1083,10 @@
 	id.filename = filename;
 	id.inum = NULL;
 
-	index = (1 << (dip->i_di.di_depth))-1;
+	lindex = (1 << (dip->i_di.di_depth))-1;
 
-	for(; (index >= 0) && !found; index--){
-		error = get_leaf_nr(dip, index, &leaf_no);
+	for(; (lindex >= 0) && !found; lindex--){
+		error = get_leaf_nr(dip, lindex, &leaf_no);
 		if (error){
 			log_err("dir_e_del:  Unable to get leaf number.\n");
 			return error;
@@ -1230,7 +1230,7 @@
 	osi_buf_t *bh, *nbh, *dibh;
 	struct gfs_leaf *leaf, *nleaf;
 	struct gfs_dirent *dent;
-	uint32 hsize, index;
+	uint32 hsize, lindex;
 	uint32 hash;
 	uint64 leaf_no, bn;
 	int error;
@@ -1248,10 +1248,10 @@
 	/*  Figure out the address of the leaf node.  */
 
 	hash = dir_hash(filename);
-	index = hash >> (32 - dip->i_di.di_depth);
+	lindex = hash >> (32 - dip->i_di.di_depth);
 
 
-	error = get_leaf_nr(dip, index, &leaf_no);
+	error = get_leaf_nr(dip, lindex, &leaf_no);
 	if (error){
 		log_err("dir_e_add:  Unable to get leaf number.\n");
 		return error;
@@ -1275,7 +1275,7 @@
 				/*  Can we split the leaf?  */
 				relse_buf(sdp, bh);
 
-				error = dir_split_leaf(dip, index, leaf_no);
+				error = dir_split_leaf(dip, lindex, leaf_no);
 				if (error){
 					log_err("dir_e_add:  Unable to split leaf.\n");
 					return error;
@@ -1598,20 +1598,20 @@
 
 
 /**
- * get_leaf_nr - Get a leaf number associated with the index
+ * get_leaf_nr - Get a leaf number associated with the lindex
  * @dip: The GFS inode
- * @index:
+ * @lindex:
  * @leaf_out:
  *
  * Returns: 0 on success, error code otherwise
  */
 
-int get_leaf_nr(struct fsck_inode *dip, uint32 index, uint64 *leaf_out)
+int get_leaf_nr(struct fsck_inode *dip, uint32 lindex, uint64 *leaf_out)
 {
 	uint64 leaf_no;
 	int error = -1;
 	error = readi(dip, (char *)&leaf_no,
-		      index * sizeof(uint64), sizeof(uint64));
+		      lindex * sizeof(uint64), sizeof(uint64));
 	if (error != sizeof(uint64)){
 		log_debug("get_leaf_nr:  Bad internal read.  (rtn = %d)\n",
 			  error);
@@ -1625,15 +1625,15 @@
 
 
 /**
- * put_leaf_nr - Put a leaf number associated with the index
+ * put_leaf_nr - Put a leaf number associated with the lindex
  * @dip: The GFS inode
- * @index:
+ * @lindex:
  * @leaf_out:
  *
  * Returns: 0 on success, error code otherwise
  */
 
-int put_leaf_nr(struct fsck_inode *dip, uint32 index, uint64 leaf_out)
+int put_leaf_nr(struct fsck_inode *dip, uint32 lindex, uint64 leaf_out)
 {
 	uint64 leaf_no;
 	int error = -1;
@@ -1641,7 +1641,7 @@
 	leaf_no = cpu_to_gfs64(leaf_out);
 
 	error = writei(dip, (char *)&leaf_no,
-		       index * sizeof(uint64), sizeof(uint64));
+		       lindex * sizeof(uint64), sizeof(uint64));
 	if (error != sizeof(uint64)){
 		log_debug("put_leaf_nr:  Bad internal write.  (rtn = %d)\n",
 			  error);
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/fs_inode.c cluster-3.0.0.rc3/gfs/gfs_fsck/fs_inode.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/fs_inode.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/fs_inode.c	2009-06-11 11:02:55.000000000 +0200
@@ -307,7 +307,7 @@
 	return error;
 }
 
-int fs_createi(struct fsck_inode *dip, osi_filename_t *name,
+static int fs_createi(struct fsck_inode *dip, osi_filename_t *name,
 	       unsigned int type, unsigned int mode, osi_cred_t *cred,
 	       int *new, struct fsck_inode **ipp)
 {
@@ -492,7 +492,7 @@
  *
  * Returns: 0 on success, -1 on failure.
  */
-int fs_mkdir(struct fsck_inode *dip, char *new_dir, int mode, struct fsck_inode **nip){
+int fs_mkdir(struct fsck_inode *dip, const char *new_dir, int mode, struct fsck_inode **nip){
 	int error;
 	osi_cred_t creds;
 	osi_buf_t *dibh;
@@ -501,7 +501,7 @@
 	struct fsck_inode *ip= NULL;
 	struct fsck_sb *sdp = dip->i_sbd;
 	osi_filename_t name;
-	int new;
+	int new = 0;
 
 	name.name = (unsigned char *)new_dir;
 	name.len = strlen(new_dir);
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/fs_inode.h cluster-3.0.0.rc3/gfs/gfs_fsck/fs_inode.h
--- cluster-3.0.0.rc2/gfs/gfs_fsck/fs_inode.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/fs_inode.h	2009-06-11 11:02:55.000000000 +0200
@@ -5,7 +5,7 @@
 
 int fs_copyin_dinode(struct fsck_inode *ip, osi_buf_t *bh);
 int fs_copyout_dinode(struct fsck_inode *ip);
-int fs_mkdir(struct fsck_inode *dip, char *new_dir, int mode, struct fsck_inode **nip);
+int fs_mkdir(struct fsck_inode *dip, const char *new_dir, int mode, struct fsck_inode **nip);
 int fs_remove(struct fsck_inode *ip);
 
 static __inline__ int fs_is_stuffed(struct fsck_inode *ip)
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/initialize.c cluster-3.0.0.rc3/gfs/gfs_fsck/initialize.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/initialize.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/initialize.c	2009-06-11 11:02:55.000000000 +0200
@@ -18,7 +18,7 @@
  *
  * Go through journals and replay them - then clear them
  */
-int init_journals(struct fsck_sb *sbp)
+static int init_journals(struct fsck_sb *sbp)
 {
 
 	if(!sbp->opts->no) {
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/log.c cluster-3.0.0.rc3/gfs/gfs_fsck/log.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/log.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/log.c	2009-06-11 11:02:55.000000000 +0200
@@ -26,7 +26,7 @@
 	_state.print_level--;
 }
 
-void print_msg(int priority, char *file, int line, const char *format, va_list args) {
+static void print_msg(int priority, const char *file, int line, const char *format, va_list args) {
 
 	switch (priority) {
 
@@ -51,7 +51,7 @@
 }
 
 
-void print_fsck_log(int iif, int priority, char *file, int line, const char *format, ...)
+void print_fsck_log(int iif, int priority, const char *file, int line, const char *format, ...)
 {
 
 	va_list args;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/log.h cluster-3.0.0.rc3/gfs/gfs_fsck/log.h
--- cluster-3.0.0.rc2/gfs/gfs_fsck/log.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/log.h	2009-06-11 11:02:55.000000000 +0200
@@ -80,7 +80,7 @@
 
 void increase_verbosity(void);
 void decrease_verbosity(void);
-void print_fsck_log(int iif, int priority, char *file, int line, const char *format, ...);
+void print_fsck_log(int iif, int priority, const char *file, int line, const char *format, ...);
 int query(struct fsck_sb *sbp, const char *format, ...);
 
 
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/main.c cluster-3.0.0.rc3/gfs/gfs_fsck/main.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -14,7 +14,8 @@
 int skip_this_pass = FALSE, fsck_abort = FALSE, fsck_query = FALSE;
 const char *pass = "";
 
-void print_map(struct block_list *il, int count)
+#if 0
+static void print_map(struct block_list *il, int count)
 {
 	int i, j;
 	struct block_query k;
@@ -36,20 +37,21 @@
 	}
 	log_info("\n");
 }
+#endif
 
-void usage(char *name)
+static void usage(char *name)
 {
 	printf("Usage: %s [-hnqvVy] <device> \n", basename(name));
 }
 
-void version(void)
+static void version(void)
 {
 	printf("GFS fsck %s (built %s %s)\n",
 	       RELEASE_VERSION, __DATE__, __TIME__);
 	printf("%s\n", REDHAT_COPYRIGHT);
 }
 
-int read_cmdline(int argc, char **argv, struct options *opts)
+static int read_cmdline(int argc, char **argv, struct options *opts)
 {
 	int c;
 
@@ -102,7 +104,7 @@
 	return 0;
 }
 
-void interrupt(int sig)
+static void interrupt(int sig)
 {
 	fd_set rfds;
 	struct timeval tv;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/metawalk.c cluster-3.0.0.rc3/gfs/gfs_fsck/metawalk.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/metawalk.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/metawalk.c	2009-06-11 11:02:55.000000000 +0200
@@ -8,7 +8,7 @@
 
 #include "metawalk.h"
 
-int check_entries(struct fsck_inode *ip, osi_buf_t *bh, int index,
+static int check_entries(struct fsck_inode *ip, osi_buf_t *bh, int lindex,
 		  int type, int *update, uint16_t *count,
 		  struct metawalk_fxns *pass)
 {
@@ -114,8 +114,8 @@
 /* so that they replace the bad ones.  We have to hack up the old    */
 /* leaf a bit, but it's better than deleting the whole directory,    */
 /* which is what used to happen before.                              */
-void warn_and_patch(struct fsck_inode *ip, uint64_t *leaf_no, 
-		    uint64_t *bad_leaf, uint64_t old_leaf, int index,
+static void warn_and_patch(struct fsck_inode *ip, uint64_t *leaf_no, 
+		    uint64_t *bad_leaf, uint64_t old_leaf, int lindex,
 		    const char *msg)
 {
 	if (*bad_leaf != *leaf_no) {
@@ -125,7 +125,7 @@
 	}
 	if (*leaf_no == *bad_leaf ||
 	    query(ip->i_sbd, "Attempt to patch around it? (y/n) ")) {
-		put_leaf_nr(ip, index, old_leaf);
+		put_leaf_nr(ip, lindex, old_leaf);
 	}
 	else
 		log_err("Bad leaf left in place.\n");
@@ -134,28 +134,28 @@
 }
 
 /* Checks exthash directory entries */
-int check_leaf(struct fsck_inode *ip, int *update, struct metawalk_fxns *pass)
+static int check_leaf(struct fsck_inode *ip, int *update, struct metawalk_fxns *pass)
 {
 	int error;
 	struct gfs_leaf leaf, oldleaf;
 	uint64_t leaf_no, old_leaf, bad_leaf = -1;
 	osi_buf_t *lbh;
-	int index;
+	int lindex;
 	struct fsck_sb *sbp = ip->i_sbd;
 	uint16_t count;
 	int ref_count = 0, exp_count = 0;
 
 	old_leaf = 0;
 	memset(&oldleaf, 0, sizeof(oldleaf));
-	for(index = 0; index < (1 << ip->i_di.di_depth); index++) {
-		if(get_leaf_nr(ip, index, &leaf_no)) {
+	for(lindex = 0; lindex < (1 << ip->i_di.di_depth); lindex++) {
+		if(get_leaf_nr(ip, lindex, &leaf_no)) {
 			log_err("Unable to get leaf block number in dir %"
 				PRIu64"\n"
 				"\tDepth = %u\n"
-				"\tindex = %u\n",
+				"\tlindex = %u\n",
 				ip->i_num.no_addr,
 				ip->i_di.di_depth,
-				index);
+				lindex);
 			return -1;
 		}
 
@@ -163,7 +163,7 @@
 		 * until those extra pointers are needed, so skip the
 		 * dups */
 		if (leaf_no == bad_leaf) {
-			put_leaf_nr(ip, index, old_leaf); /* fill w/old leaf */
+			put_leaf_nr(ip, lindex, old_leaf); /* fill w/old leaf */
 			ref_count++;
 			continue;
 		}
@@ -208,7 +208,7 @@
 					"range for directory #%"PRIu64".\n",
 					leaf_no, ip->i_di.di_num.no_addr);
 				warn_and_patch(ip, &leaf_no, &bad_leaf,
-					       old_leaf, index,
+					       old_leaf, lindex,
 					       "that is out of range");
 				memcpy(&leaf, &oldleaf, sizeof(oldleaf));
 				break;
@@ -220,7 +220,7 @@
 					"directory #%"PRIu64".\n",
 					leaf_no, ip->i_di.di_num.no_addr);
 				warn_and_patch(ip, &leaf_no, &bad_leaf,
-					       old_leaf, index,
+					       old_leaf, lindex,
 					       "that cannot be read");
 				memcpy(&leaf, &oldleaf, sizeof(oldleaf));
 				relse_buf(sbp, lbh);
@@ -229,7 +229,7 @@
 			/* Make sure it's really a valid leaf block. */
 			if (check_meta(lbh, GFS_METATYPE_LF)) {
 				warn_and_patch(ip, &leaf_no, &bad_leaf,
-					       old_leaf, index,
+					       old_leaf, lindex,
 					       "that is not really a leaf");
 				memcpy(&leaf, &oldleaf, sizeof(oldleaf));
 				relse_buf(sbp, lbh);
@@ -246,7 +246,7 @@
 				  ip->i_di.di_depth, leaf.lf_depth);
 			if(pass->check_dentry && 
 			   ip->i_di.di_type == GFS_FILE_DIR) {
-				error = check_entries(ip, lbh, index,
+				error = check_entries(ip, lbh, lindex,
 						      DIR_EXHASH, update,
 						      &count,
 						      pass);
@@ -696,7 +696,7 @@
 
 
 /* Checks stuffed inode directories */
-int check_linear_dir(struct fsck_inode *ip, osi_buf_t *bh, int *update,
+static int check_linear_dir(struct fsck_inode *ip, osi_buf_t *bh, int *update,
 		     struct metawalk_fxns *pass)
 {
 	int error = 0;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/ondisk.c cluster-3.0.0.rc3/gfs/gfs_fsck/ondisk.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/ondisk.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/ondisk.c	2009-06-11 11:02:55.000000000 +0200
@@ -41,7 +41,7 @@
  */
 
 static void
-print_array(char *title, char *buf, int count, int console)
+print_array(const char *title, char *buf, int count, int console)
 {
 	int x;
 
@@ -349,20 +349,20 @@
  */
 
 void
-gfs_rindex_in(struct gfs_rindex *rindex, char *buf)
+gfs_rindex_in(struct gfs_rindex *grindex, char *buf)
 {
 	struct gfs_rindex *str = (struct gfs_rindex *) buf;
 
-	CPIN_64(rindex, str, ri_addr);
-	CPIN_32(rindex, str, ri_length);
-	CPIN_32(rindex, str, ri_pad);
+	CPIN_64(grindex, str, ri_addr);
+	CPIN_32(grindex, str, ri_length);
+	CPIN_32(grindex, str, ri_pad);
 
-	CPIN_64(rindex, str, ri_data1);
-	CPIN_32(rindex, str, ri_data);
+	CPIN_64(grindex, str, ri_data1);
+	CPIN_32(grindex, str, ri_data);
 
-	CPIN_32(rindex, str, ri_bitbytes);
+	CPIN_32(grindex, str, ri_bitbytes);
 
-	CPIN_08(rindex, str, ri_reserved, 64);
+	CPIN_08(grindex, str, ri_reserved, 64);
 
 }
 
@@ -374,20 +374,20 @@
  */
 
 void
-gfs_rindex_out(struct gfs_rindex *rindex, char *buf)
+gfs_rindex_out(struct gfs_rindex *grindex, char *buf)
 {
 	struct gfs_rindex *str = (struct gfs_rindex *) buf;
 
-	CPOUT_64(rindex, str, ri_addr);
-	CPOUT_32(rindex, str, ri_length);
-	CPOUT_32(rindex, str, ri_pad);
+	CPOUT_64(grindex, str, ri_addr);
+	CPOUT_32(grindex, str, ri_length);
+	CPOUT_32(grindex, str, ri_pad);
 
-	CPOUT_64(rindex, str, ri_data1);
-	CPOUT_32(rindex, str, ri_data);
+	CPOUT_64(grindex, str, ri_data1);
+	CPOUT_32(grindex, str, ri_data);
 
-	CPOUT_32(rindex, str, ri_bitbytes);
+	CPOUT_32(grindex, str, ri_bitbytes);
 
-	CPOUT_08(rindex, str, ri_reserved, 64);
+	CPOUT_08(grindex, str, ri_reserved, 64);
 
 }
 
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/pass1b.c cluster-3.0.0.rc3/gfs/gfs_fsck/pass1b.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/pass1b.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/pass1b.c	2009-06-11 11:02:55.000000000 +0200
@@ -317,7 +317,7 @@
 }
 
 /* Finds all references to duplicate blocks in the metadata */
-int find_block_ref(struct fsck_sb *sbp, uint64_t inode, struct blocks *b)
+static int find_block_ref(struct fsck_sb *sbp, uint64_t inode, struct blocks *b)
 {
 	struct fsck_inode *ip;
 	struct fxn_info myfi = {b->block_no, 0, 1};
@@ -371,7 +371,7 @@
 }
 
 /* Finds all blocks marked in the duplicate block bitmap */
-int find_dup_blocks(struct fsck_sb *sbp)
+static int find_dup_blocks(struct fsck_sb *sbp)
 {
 	uint64_t block_no = 0;
 	struct blocks *b;
@@ -396,7 +396,7 @@
 
 
 
-int handle_dup_blk(struct fsck_sb *sbp, struct blocks *b)
+static int handle_dup_blk(struct fsck_sb *sbp, struct blocks *b)
 {
 	osi_list_t *tmp;
 	struct inode_with_dups *id;
@@ -462,9 +462,10 @@
 	struct block_query q;
 	osi_list_t *tmp;
 	struct metawalk_fxns find_dirents = {0};
-	find_dirents.check_dentry = &find_dentry;
 	int rc = 0;
 
+	find_dirents.check_dentry = &find_dentry;
+
 	osi_list_init(&sbp->dup_list);
 	/* Shove all blocks marked as duplicated into a list */
 	log_info("Looking for duplicate blocks...\n");
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/pass1.c cluster-3.0.0.rc3/gfs/gfs_fsck/pass1.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/pass1.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/pass1.c	2009-06-11 11:02:55.000000000 +0200
@@ -528,7 +528,7 @@
 	return 0;
 }
 
-int clear_metalist(struct fsck_inode *ip, uint64_t block,
+static int clear_metalist(struct fsck_inode *ip, uint64_t block,
 		   osi_buf_t **bh, void *private)
 {
 	struct fsck_sb *sdp = ip->i_sbd;
@@ -547,7 +547,7 @@
 	return 0;
 }
 
-int clear_data(struct fsck_inode *ip, uint64_t block, void *private)
+static int clear_data(struct fsck_inode *ip, uint64_t block, void *private)
 {
 	struct fsck_sb *sdp = ip->i_sbd;
 	struct block_query q = {0};
@@ -564,7 +564,7 @@
 
 }
 
-int clear_leaf(struct fsck_inode *ip, uint64_t block,
+static int clear_leaf(struct fsck_inode *ip, uint64_t block,
 	       osi_buf_t *bh, void *private)
 {
 
@@ -621,7 +621,7 @@
 }
 
 
-int handle_di(struct fsck_sb *sdp, osi_buf_t *bh, uint64_t block, int mfree)
+static int handle_di(struct fsck_sb *sdp, osi_buf_t *bh, uint64_t block, int mfree)
 {
 	struct block_query q = {0};
 	struct fsck_inode *ip;
@@ -878,7 +878,7 @@
 }
 
 
-int scan_meta(struct fsck_sb *sdp, osi_buf_t *bh, uint64_t block, int mfree)
+static int scan_meta(struct fsck_sb *sdp, osi_buf_t *bh, uint64_t block, int mfree)
 {
 
 	if (check_meta(bh, 0)) {
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/pass1c.c cluster-3.0.0.rc3/gfs/gfs_fsck/pass1c.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/pass1c.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/pass1c.c	2009-06-11 11:02:55.000000000 +0200
@@ -15,11 +15,16 @@
 	if(!prev){
 		curr->ea_type = GFS_EATYPE_UNUSED;
 	} else {
+		uint32_t curr_rec_len;
+		uint32_t prev_rec_len;
+
+		curr_rec_len = gfs32_to_cpu(curr->ea_rec_len);
+		prev_rec_len = gfs32_to_cpu(prev->ea_rec_len);
+
 		prev->ea_rec_len =
-			cpu_to_gfs32(gfs32_to_cpu(curr->ea_rec_len) +
-				     gfs32_to_cpu(prev->ea_rec_len));
+			cpu_to_gfs32(curr_rec_len + prev_rec_len);
 		if (curr->ea_flags & GFS_EAFLAG_LAST)
-			prev->ea_flags |= GFS_EAFLAG_LAST;	
+			prev->ea_flags |= GFS_EAFLAG_LAST;
 	}
 	if(write_buf(sdp, leaf_bh, 0)){
 		stack;
@@ -29,7 +34,7 @@
 	return 0;
 }
 
-int check_eattr_indir(struct fsck_inode *ip, uint64_t block,
+static int check_eattr_indir(struct fsck_inode *ip, uint64_t block,
 		      uint64_t parent, osi_buf_t **bh,
 		      void *private)
 {
@@ -65,7 +70,8 @@
 	*bh = indir_bh;
 	return 0;
 }
-int check_eattr_leaf(struct fsck_inode *ip, uint64_t block,
+
+static int check_eattr_leaf(struct fsck_inode *ip, uint64_t block,
 		     uint64_t parent, osi_buf_t **bh, void *private)
 {
 	int *update = (int *) private;
@@ -198,7 +204,7 @@
 	return 0;
 }
 
-int check_eattr_extentry(struct fsck_inode *ip, uint64_t *ea_ptr,
+static int check_eattr_extentry(struct fsck_inode *ip, uint64_t *ea_ptr,
 			 osi_buf_t *leaf_bh,
 			 struct gfs_ea_header *ea_hdr,
 			 struct gfs_ea_header *ea_hdr_prev,
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/pass2.c cluster-3.0.0.rc3/gfs/gfs_fsck/pass2.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/pass2.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/pass2.c	2009-06-11 11:02:55.000000000 +0200
@@ -25,7 +25,7 @@
 
 /* Set children's parent inode in dir_info structure - ext2 does not set
  * dotdot inode here, but instead in pass3 - should we? */
-int set_parent_dir(struct fsck_sb *sbp, uint64_t childblock,
+static int set_parent_dir(struct fsck_sb *sbp, uint64_t childblock,
 		   uint64_t parentblock)
 {
 	struct dir_info *di;
@@ -51,7 +51,7 @@
 }
 
 /* Set's the child's '..' directory inode number in dir_info structure */
-int set_dotdot_dir(struct fsck_sb *sbp, uint64_t childblock,
+static int set_dotdot_dir(struct fsck_sb *sbp, uint64_t childblock,
 		   uint64_t parentblock)
 {
 	struct dir_info *di;
@@ -142,7 +142,7 @@
 
 /* FIXME: should maybe refactor this a bit - but need to deal with
  * FIXMEs internally first */
-int check_dentry(struct fsck_inode *ip, struct gfs_dirent *dent,
+static int check_dentry(struct fsck_inode *ip, struct gfs_dirent *dent,
 		 struct gfs_dirent *prev_de,
 		 osi_buf_t *bh, char *filename, int *update,
 		 uint16_t *count, void *priv)
@@ -501,7 +501,7 @@
 
 
 
-int build_rooti(struct fsck_sb *sbp)
+static int build_rooti(struct fsck_sb *sbp)
 {
 	struct fsck_inode *ip;
 	osi_buf_t *bh;
@@ -553,7 +553,7 @@
 }
 
 /* Check root inode and verify it's in the bitmap */
-int check_root_dir(struct fsck_sb *sbp)
+static int check_root_dir(struct fsck_sb *sbp)
 {
 	uint64_t rootblock;
 	struct dir_status ds = {0};
@@ -730,11 +730,12 @@
 	osi_buf_t b, *bh = &b;
 	osi_filename_t filename;
 	char tmp_name[256];
+	int error = 0;
+
 	if(check_root_dir(sbp)) {
 		stack;
 		return -1;
 	}
-	int error = 0;
 
 	log_info("Checking directory inodes.\n");
 	/* Grab each directory inode, and run checks on it */
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/pass3.c cluster-3.0.0.rc3/gfs/gfs_fsck/pass3.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/pass3.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/pass3.c	2009-06-11 11:02:55.000000000 +0200
@@ -56,7 +56,7 @@
 	return 0;
 }
 
-struct dir_info *mark_and_return_parent(struct fsck_sb *sbp,
+static struct dir_info *mark_and_return_parent(struct fsck_sb *sbp,
 					struct dir_info *di)
 {
 	struct dir_info *pdi;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/pass4.c cluster-3.0.0.rc3/gfs/gfs_fsck/pass4.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/pass4.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/pass4.c	2009-06-11 11:02:55.000000000 +0200
@@ -9,7 +9,7 @@
 
 /* Updates the link count of an inode to what the fsck has seen for
  * link count */
-int fix_inode_count(struct fsck_sb *sbp, struct inode_info *ii,
+static int fix_inode_count(struct fsck_sb *sbp, struct inode_info *ii,
 		    struct fsck_inode *ip)
 {
 	log_info("Fixing inode count for %"PRIu64"\n",
@@ -26,7 +26,7 @@
 	return 0;
 }
 
-int scan_inode_list(struct fsck_sb *sbp, osi_list_t *list) {
+static int scan_inode_list(struct fsck_sb *sbp, osi_list_t *list) {
 	osi_list_t *tmp;
 	struct inode_info *ii;
 	struct fsck_inode *ip;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/pass5.c cluster-3.0.0.rc3/gfs/gfs_fsck/pass5.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/pass5.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/pass5.c	2009-06-11 11:02:55.000000000 +0200
@@ -119,7 +119,7 @@
 }
 #endif /* DEBUG */
 
-int convert_mark(enum mark_block mark, uint32_t *count)
+static int convert_mark(enum mark_block mark, uint32_t *count)
 {
 	switch(mark) {
 
@@ -163,7 +163,7 @@
 }
 
 
-int check_block_status(struct fsck_sb *sbp, char *buffer, unsigned int buflen,
+static int check_block_status(struct fsck_sb *sbp, char *buffer, unsigned int buflen,
 		       uint64_t *rg_block, uint64_t rg_data, uint32_t *count)
 {
 	unsigned char *byte, *end;
@@ -240,7 +240,7 @@
 #define FREE_META_COUNT  16
 #define CONVERT_FREEMETA_TO_FREE (FREE_COUNT | FREE_META_COUNT)
 
-int update_rgrp(struct fsck_rgrp *rgp, uint32_t *count, int rgcount)
+static int update_rgrp(struct fsck_rgrp *rgp, uint32_t *count, int rgcount)
 {
 	uint32_t i;
 	fs_bitmap_t *bits;
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/super.c cluster-3.0.0.rc3/gfs/gfs_fsck/super.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/super.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/super.c	2009-06-11 11:02:55.000000000 +0200
@@ -220,7 +220,7 @@
 }
 
 /* Print out debugging information in same format as gfs_edit. */
-int hexdump(uint64 startaddr, const unsigned char *lpBuffer, int len)
+static int hexdump(uint64 startaddr, const unsigned char *lpBuffer, int len)
 {
 	const unsigned char *pointer, *ptr2;
 	int i;
@@ -264,7 +264,7 @@
  * Returns: the number of bitmap blocks
  */
 
-uint32 rgrplength2bitblocks(struct fsck_sb *sdp, uint32 length)
+static uint32 rgrplength2bitblocks(struct fsck_sb *sdp, uint32 length)
 {
 	uint32 bitbytes;
 	uint32 old_blocks = 0, blocks;
@@ -342,7 +342,7 @@
  * will have the same number of RGs as the second original subdevice.
  * Other RGs found after that will be considered "extra."
  */
-int gfs_rgindex_rebuild(struct fsck_sb *sdp, osi_list_t *ret_list,
+static int gfs_rgindex_rebuild(struct fsck_sb *sdp, osi_list_t *ret_list,
 			unsigned int *num_rgs)
 {
 	osi_buf_t *bh; /* buffer handle */
@@ -959,7 +959,7 @@
  * Sets:    ret_list to a linked list of fsck_rgrp structs representing
  *          what we think the rgindex should really look like.
  */
-int gfs_rgindex_calculate(struct fsck_sb *sdp, osi_list_t *ret_list,
+static int gfs_rgindex_calculate(struct fsck_sb *sdp, osi_list_t *ret_list,
 			  unsigned int *num_rgs)
 {
 	osi_buf_t *bh; /* buffer handle */
@@ -1105,7 +1105,7 @@
 /*
  * ri_cleanup - free up the memory we previously allocated.
  */
-void ri_cleanup(osi_list_t *rglist)
+static void ri_cleanup(osi_list_t *rglist)
 {
 	struct fsck_rgrp *rgd;
 
@@ -1144,7 +1144,7 @@
 	osi_list_t expected_rglist; /* List of expected resource groups */
 	osi_list_t *tmp;
 	struct gfs_rindex buf;
-	unsigned int rg, calc_rg_count;
+	unsigned int rg, calc_rg_count = 0;
 	int error, count1 = 0, count2 = 0;
 	int fix_grow_problems = 0, grow_problems = 0;
 	enum rgindex_trust_level { /* how far can we trust our RG index? */
diff -Naurd cluster-3.0.0.rc2/gfs/gfs_fsck/util.c cluster-3.0.0.rc3/gfs/gfs_fsck/util.c
--- cluster-3.0.0.rc2/gfs/gfs_fsck/util.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs/gfs_fsck/util.c	2009-06-11 11:02:55.000000000 +0200
@@ -90,13 +90,13 @@
  */
 int check_meta(osi_buf_t *bh, int type){
   uint32 check_magic = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_magic;
-  uint32 check_type = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_type;
+  uint32 check_metatype = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_type;
  
   check_magic = gfs32_to_cpu(check_magic);
-  check_type = gfs32_to_cpu(check_type);
-  if((check_magic != GFS_MAGIC) || (type && (check_type != type))){
+  check_metatype = gfs32_to_cpu(check_metatype);
+  if((check_magic != GFS_MAGIC) || (type && (check_metatype != type))){
 	  log_debug("For %"PRIu64" Expected %X:%X - got %X:%X\n", BH_BLKNO(bh), GFS_MAGIC, type,
-		    check_magic, check_type);
+		    check_magic, check_metatype);
     return -1;
   }
   return 0;
@@ -111,11 +111,11 @@
  */
 int check_type(osi_buf_t *bh, int type){
   uint32 check_magic = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_magic;
-  uint32 check_type = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_type;
+  uint32 check_metatype = ((struct gfs_meta_header *)BH_DATA((bh)))->mh_type;
  
   check_magic = gfs32_to_cpu(check_magic);
-  check_type = gfs32_to_cpu(check_type);
-  if((check_magic != GFS_MAGIC) || (check_type != type)){
+  check_metatype = gfs32_to_cpu(check_metatype);
+  if((check_magic != GFS_MAGIC) || (check_metatype != type)){
     return -1;
   }
   return 0;
